using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace OpenSelectedMailItem
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("9323ABD3-DFDA-472A-B27D-66318ACCCD6A"), ProgId("OpenSelectedMailItem.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            InitializeComponent();
        }

        private AddinExpress.OL.ADXOlFormsManager adxOlFormsManager1;
        private AddinExpress.OL.ADXOlFormsCollectionItem adxOlFormsCollectionItem1;
        private AddinExpress.OL.ADXOlFormsCollectionItem adxOlFormsCollectionItem2;
        private AddinExpress.MSO.ADXOutlookAppEvents adxOutlookEvents;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxOlFormsManager1 = new AddinExpress.OL.ADXOlFormsManager(this.components);
            this.adxOlFormsCollectionItem1 = new AddinExpress.OL.ADXOlFormsCollectionItem(this.components);
            this.adxOlFormsCollectionItem2 = new AddinExpress.OL.ADXOlFormsCollectionItem(this.components);
            this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
            // 
            // adxOlFormsManager1
            // 
            this.adxOlFormsManager1.Items.Add(this.adxOlFormsCollectionItem1);
            this.adxOlFormsManager1.Items.Add(this.adxOlFormsCollectionItem2);
            this.adxOlFormsManager1.SetOwner(this);
            // 
            // adxOlFormsCollectionItem1
            // 
            this.adxOlFormsCollectionItem1.Cached = AddinExpress.OL.ADXOlCachingStrategy.OneInstanceForAllFolders;
            this.adxOlFormsCollectionItem1.ExplorerItemTypes = AddinExpress.OL.ADXOlExplorerItemTypes.olMailItem;
            this.adxOlFormsCollectionItem1.ExplorerLayout = AddinExpress.OL.ADXOlExplorerLayout.BottomSubpane;
            this.adxOlFormsCollectionItem1.FormClassName = "OpenSelectedMailItem.ADXOlForm1";
            // 
            // adxOlFormsCollectionItem2
            // 
            this.adxOlFormsCollectionItem2.Enabled = false;
            this.adxOlFormsCollectionItem2.FormClassName = "OpenSelectedMailItem.ADXOlForm2";
            this.adxOlFormsCollectionItem2.InspectorItemTypes = AddinExpress.OL.ADXOlInspectorItemTypes.olMail;
            this.adxOlFormsCollectionItem2.InspectorLayout = AddinExpress.OL.ADXOlInspectorLayout.RightSubpane;
            // 
            // adxOutlookEvents
            // 
            this.adxOutlookEvents.ExplorerSelectionChange += new AddinExpress.MSO.ADXOlExplorer_EventHandler(this.adxOutlookEvents_ExplorerSelectionChange);
            // 
            // AddinModule
            // 
            this.AddinName = "OpenSelectedMailItem";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;

        }
        #endregion
 
        #region Add-in Express automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private ADXOlForm1 _explorerForm = null;
        public ADXOlForm1 ExplorerForm
        {
            get { return _explorerForm; }
            set { _explorerForm = value; }
        }

        public void OpenCurrentMail()
        {
            Outlook.Explorer explorer = OutlookApp.ActiveExplorer() as Outlook.Explorer;
            Outlook.Selection selection = explorer.Selection;
            Outlook.Inspectors inspectors = OutlookApp.Inspectors;
            Outlook.MailItem mail = null;
            object selectedItem = null;
            Outlook.Inspector inspector = null;
            try
            {
                if (selection.Count == 1)
                {
                    selectedItem = selection[1];
                    if (selectedItem is Outlook.MailItem)
                    {
                        try
                        {
                            //prevent cached forms from being deleted 
                            adxOlFormsManager1.LockUpdates();
                            //enable the item to display the Inspector right pane
                            adxOlFormsCollectionItem2.Enabled = true; 
                            mail = selectedItem as Outlook.MailItem;
                            inspector = inspectors.Add(mail);
                            inspector.Display(false);
                            //disable the item for the Inspector Right Pane not to be displayed
                            adxOlFormsCollectionItem2.Enabled = false; 

                        }
                        finally
                        {
                            adxOlFormsManager1.UnlockUpdates(); 
                        }
                    }
                }
            }
            finally
            {
                if (explorer != null)
                {
                    Marshal.ReleaseComObject(explorer);
                }
                if (selection != null)
                {
                    Marshal.ReleaseComObject(selection);
                }
                if (selectedItem != null)
                {
                    Marshal.ReleaseComObject(selectedItem);
                }
                if (mail != null)
                {
                    Marshal.ReleaseComObject(mail);
                }
                if (inspectors != null)
                {
                    Marshal.ReleaseComObject(inspectors);
                }
                if (inspector != null)
                {
                    Marshal.ReleaseComObject(inspector);
                }
            }

        }

        private void CheckSelection()
        {
            if (ExplorerForm == null)
                return;

            //disable the button by default
            ExplorerForm.button1.Enabled = false;

            Outlook.Explorer explorer = OutlookApp.ActiveExplorer() as Outlook.Explorer;
            Outlook.Selection selection = explorer.Selection;
            Outlook.Inspectors inspectors = OutlookApp.Inspectors;
            Outlook.MailItem mail = null;
            object selectedItem = null;
            Outlook.Inspector inspector = null;
            try
            {
                if (selection.Count == 1)
                {
                    selectedItem = selection[1];
                    if (selectedItem is Outlook.MailItem)
                    {
                        try
                        {
                            mail = selectedItem as Outlook.MailItem;
                            bool EnableCondition = (mail.Subject == "Add-in Express");
                            
                            //disable/enable the button
                            ExplorerForm.button1.Enabled = EnableCondition;

                        }
                        finally
                        {
                            adxOlFormsManager1.UnlockUpdates();
                        }
                    }
                }
            }
            finally
            {
                if (explorer != null)
                {
                    Marshal.ReleaseComObject(explorer);
                }
                if (selection != null)
                {
                    Marshal.ReleaseComObject(selection);
                }
                if (selectedItem != null)
                {
                    Marshal.ReleaseComObject(selectedItem);
                }
                if (mail != null)
                {
                    Marshal.ReleaseComObject(mail);
                }
                if (inspectors != null)
                {
                    Marshal.ReleaseComObject(inspectors);
                }
                if (inspector != null)
                {
                    Marshal.ReleaseComObject(inspector);
                }
            }

        }

        private void adxOutlookEvents_ExplorerSelectionChange(object sender, object explorer)
        {
            CheckSelection();
        }

    }
}

